<%
  let paths, querys
  let args = []

  // params
  if (api.parameters) {
    paths = api.parameters.filter(p => p.in === "path")
    args = args.concat(paths.map(p => {
      switch (p.schema.type) {
        case "integer":
          return `parseInt(req.params.${p.name})`
        case "number":
          return `parseFloat(req.params.${p.name})`
        default:
          return `req.params.${p.name}`
      }
    }))
  }

  // body
  const existBody = api.requestBody && api.requestBody.content && api.requestBody.content["application/json"]
  if (existBody) {
    args.push("req.body")
  }

  // query
  if (api.parameters) {
    querys = api.parameters.filter(p => p.in === "query")
    if (querys.length > 0) {
      args.push("req.query")
    }
  }
%>
/* <%- api.summary %> */
app.<%- httpMethod %>(<%- _.swagger.convertPath(pathStr, "express") %>, swaggerValidation.validate, async (req: Request, res: Response, next: NextFunction) => {
  try {
    // @ts-ignore
    <%- `res.json(await ${api.tags[0]}.${api.operationId}(${args.join(", ")}))` %>
  } catch (err) {
    next(err)
  }
})
